/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#include <o2scl/misc.h>
#include <o2scl/test_mgr.h>
#include <climits>

using namespace std;
using namespace o2scl;

int main(void) {
  double x=sqrt(2.0);
  int i=3;
  string s1="4", s2="1.7320508";
  test_mgr t;
  t.set_output_level(2);
  
  cout << double_to_ieee_string(&x) << endl;
  cout << binary_to_hex(double_to_ieee_string(&x)) << endl;

  cout << "These are strings: ";
  cout << itos(i) << " " << dtos(x) << endl;
  cout << "These are numbers: ";
  cout << stoi(s1) << " " << stod(s2) << endl;
  cout << endl;

  cout << "Testing incorrect inputs: " << endl;
  cout << "stoi(\"5.6\"): \t\t" << stoi("5.6") << endl;
  cout << "stoi(\"987.6\"): \t\t" << stoi("987.6") << endl;
  cout << "stoi(\"zxqwer\"): \t" << stoi("zxqwer") << endl;
  cout << "stoi(\"234.43e1zxepq\"): \t" << stoi("234.43e1zxepq") << endl;
  cout << "stoi(\"z8n2,5\"): \t" << stoi("z8n2,5") << endl;
  cout << "stod(\"zxqwer\"): \t" << stod("zxqwer") << endl;
  cout << "stod(\"234.43e1zxepq\"): \t" << stod("234.43e1zxepq") << endl;
  cout << "stod(\"z8n2,5\"): \t" << stod("z8n2,5") << endl;

  cout << endl;
  cout << double_to_latex(-sqrt(2.0)*1.0e-5) << endl;
  cout << double_to_latex(sqrt(2.0)*1.0e-4) << endl;
  cout << double_to_latex(-sqrt(2.0)*1.0e-3) << endl;
  cout << double_to_latex(sqrt(2.0)*1.0e-2) << endl;
  cout << double_to_latex(-sqrt(2.0)*1.0e-1) << endl;
  cout << double_to_latex(sqrt(2.0)*1.0e0) << endl;
  cout << double_to_latex(-sqrt(2.0)*1.0e1) << endl;
  cout << double_to_latex(sqrt(2.0)*1.0e2) << endl;
  cout << double_to_latex(-sqrt(2.0)*1.0e3) << endl;
  cout << double_to_latex(sqrt(2.0)*1.0e4) << endl;
  cout << double_to_latex(-sqrt(2.0)*1.0e5) << endl;

  cout << endl;
  cout << double_to_latex(sqrt(2.0)*1.0e-5,3) << endl;
  cout << double_to_latex(sqrt(2.0)*1.0e-2,3) << endl;
  cout << double_to_latex(sqrt(2.0)*1.0e0,3) << endl;
  cout << double_to_latex(sqrt(2.0)*1.0e2,3) << endl;
  cout << double_to_latex(sqrt(2.0)*1.0e5,3) << endl;

  cout << endl;
  cout << double_to_html(sqrt(2.0)*1.0e-5) << endl;
  cout << double_to_html(sqrt(2.0)*1.0e-4) << endl;
  cout << double_to_html(sqrt(2.0)*1.0e-3) << endl;
  cout << double_to_html(sqrt(2.0)*1.0e-2) << endl;
  cout << double_to_html(sqrt(2.0)*1.0e-1) << endl;
  cout << double_to_html(sqrt(2.0)*1.0e0) << endl;
  cout << double_to_html(sqrt(2.0)*1.0e1) << endl;
  cout << double_to_html(sqrt(2.0)*1.0e2) << endl;
  cout << double_to_html(sqrt(2.0)*1.0e3) << endl;
  cout << double_to_html(sqrt(2.0)*1.0e4) << endl;
  cout << double_to_html(sqrt(2.0)*1.0e5) << endl;

  cout << endl;
  cout << "Show that final zeros don't work right now:" << endl;
  cout << double_to_latex((sqrt(2.0)-2.135e-4)*1.0e-5,7) << endl;

  t.report();
  return 0;
}

