/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006, 2007, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/

#include <iostream>
#include <o2scl/pinside.h>
#include <o2scl/ovector_tlate.h>

using namespace std;
using namespace o2scl;

int main(void) {
  test_mgr t;
  t.set_output_level(1);

  pinside pi;
  pi.test(t);

  ovector x, y;
  x.push_back(1); y.push_back(0);
  x.push_back(2); y.push_back(0);
  x.push_back(2); y.push_back(1);
  x.push_back(3); y.push_back(1);
  x.push_back(3); y.push_back(2);
  x.push_back(2); y.push_back(2);
  x.push_back(2); y.push_back(3);
  x.push_back(1); y.push_back(3);
  x.push_back(1); y.push_back(2);
  x.push_back(0); y.push_back(2);
  x.push_back(0); y.push_back(1);
  x.push_back(1); y.push_back(1);

  // This generates a file which should contain only the points
  // inside the region defined above (a "plus sign").

  ofstream fout("pinside.dat");
  for(double r=0.1;r<=1.501;r+=0.1) {
    for(double th=0.0;th<=2.0*acos(-1);th+=2.0*acos(-1)/300.0) {
      if (pi.inside(1.5+r*cos(th),1.5+r*sin(th),x,y)) {
	fout << 1.5+r*cos(th) << " " << 1.5+r*sin(th) << endl;
      }
    }
  }
  fout.close();

  t.report();
  return 0;
}
